;LZ4 data decompressor for Apple II
;Peter Ferrie (peter.ferrie@gmail.com)
;assemble using ACME
;dst<src
!cpu 6502
!to "lz4",plain
*=$800

init	=	0 ;set to 1 if you know the values
hiunp	=	0 ;unpacker entirely in high memory
hipak	=	0 ;packed data entirely in high memory (requires hiunp)
!if init {
  oep		=	$1234 ;first unpacked byte to run, you must set this by yourself
  orgoff	=	$1234 ;offset of first unpacked byte, you must set this by yourself
  paksize	=	$1234 ;size of packed data, you must set this by yourself if hiunp=0
}
!if hiunp {
  hioff		=	$d000 ;address of unpacker in high memory, you can change this but leave room for packed data if hipak=1
  !if hipak {
    !if (init=0) {
      paksize	=	$1234 ;size of packed data, you must set this by yourself if hiunp=1
    }
  }
} else {
  !if (init=0) {
    paksize	=	$1234 ;size of packed data, you must set this by yourself if hiunp=1
  }
}


;unpacker variables, no need to change these
src	=	$0
dst	=	$2
end	=	$4
count	=	$6
delta	=	$8
tmpy	=	$0a
A1L	=	$3c
A1H	=	$3d
A2L	=	$3e
A2H	=	$3f
A4L	=	$42
A4H	=	$43
LCBANK2	=	$c083
MOVE	=	$fe2c

!if init {
	clc
	lda	#<pakoff ;packed data offset
	sta	src
	adc	#<paksize ;packed data size
	sta	end
	lda	#>pakoff
	sta	src+1
	adc	#>paksize
	sta	end+1
	lda	#>orgoff ;original unpacked data offset
	sta	dst+1
  !if (>(oep-1)=>orgoff) { ;oep = original entrypoint
	pha
  } else {
	lda	#>(oep-1)
	pha
  }
	lda	#<orgoff
	sta	dst
  !if (<(oep-1)=<orgoff) {
	pha
  } else {
	lda	#<(oep-1)
	pha
  }
}

unpack ;unpacker entrypoint
	lda	#0
	sta	count+1
!if hiunp {
	lda	#>parsetoken
	sta	A1H
	lda	#<parsetoken
	sta	A1L
  !if hipak {
	lda	#>pakoff+paksize ;packed data offset + packed data size
	sta	A2H
	lda	#<pakoff+paksize
	sta	A2L
  } else {
	lda	#>pakoff
	sta	A2H
	lda	#<pakoff
	sta	A2L
  }
	lda	#>hioff
	sta	A4H
	lda	#<hioff
	sta	A4L
	jsr	MOVE
	lda	LCBANK2
	lda	LCBANK2
	rts
;*=$d000
} else {
	jmp	parsetoken

pakoff
	;place packed data here for low memory unpacking
*=pakoff+paksize
}

parsetoken
	lda	#1
	sta	count+1
	jsr	getsrc
	tax
	lsr
	lsr
	lsr
	lsr
	beq	copymatches
	inc	count+1
	jsr	buildcount
	tay
	jsr	docopy
	lda	src
	cmp	end
	lda	src+1
	sbc	end+1
	bcs	done

copymatches
	jsr	getsrc
	sta	delta
	jsr	getsrc
	sta	delta+1
	txa
	and	#$0f
	inc	count+1
	jsr	buildcount
	adc	#4
	tay
	lda	count+1
	adc	#0
	sta	count+1
	lda	src+1
	pha
	lda	src
	pha
	sec
	lda	dst
	sbc	delta
	sta	src
	lda	dst+1
	sbc	delta+1
	sta	src+1
	jsr	docopy
	pla
	sta	src
	pla
	sta	src+1
	jmp	parsetoken

docopy
	jsr	getput
	dey
	bne	docopy
	dec	count+1
	bne	docopy
done	rts

buildcount
	cmp	#$0f
	bne	+
	sta	count
-	jsr	getsrc
	tay
	clc
	adc	count
	sta	count
	lda	#0
	adc	count+1
	sta	count+1
	iny
	beq	-
	lda	count
+	rts

getput
	jsr	getsrc

putdst
	sty	tmpy
	ldy	#0
	sta 	(dst), y
	ldy	tmpy
	inc	dst
	bne	+
	inc	dst+1
+	rts

getsrc
	sty	tmpy
	ldy	#0
	lda 	(src), y
	ldy	tmpy
	inc	src
	bne	+
	inc	src+1
+	rts

!if hiunp {
pakoff
	;place packed data here for high memory unpacking
}
