;LZ4 data decompressor for Apple II
;Peter Ferrie (peter.ferrie@gmail.com)
;assemble using ACME
;src<dst
!cpu 6502
!to "lz4",plain
*=$800

init	=	0 ;set to 1 if you know the values
!if init {
  oep		=	$1234 ;first unpacked byte to run, you must set this by yourself
  orgoff	=	$1234 ;offset of first unpacked byte, you must set this by yourself
  orgsize	=	$1234 ;size of unpacked data, you must set this by yourself
  paksize	=	$1234 ;size of packed data, you must set this by yourself
}

;unpacker variables, no need to change these
src	=	$0
dst	=	$2
count	=	$4
delta	=	$6
tmpy	=	$8

!if init {
	lda	#>pakoff+paksize ;packed data offset + packed data size
	sta	src+1
	lda	#<pakoff+paksize
	sta	src
	lda	#>orgoff+orgsize ;original unpacked data offset + original unpacked size
	sta	dst+1
  !if (>(oep-1)=>(orgoff+orgsize)) { ;oep = original entrypoint
	pha
  } else {
	lda	#>(oep-1)
	pha
  }
	lda	#<orgoff+orgsize
	sta	dst
	lda	#<(oep-1)
	pha
}

unpack ;unpacker entrypoint
	lda	#0
	sta	count+1

parsetoken
	jsr	getsrc
	tax
	lsr
	lsr
	lsr
	lsr
	beq	copymatches
	inc	count+1
	jsr	buildcount
	tay
	jsr	docopy
	lda	src
	cmp	#<(pakoff+1)
	lda	src+1
	sbc	#>(pakoff+1)
	bcc	done

copymatches
	jsr	getsrc
	sta	delta
	jsr	getsrc
	sta	delta+1
	txa
	and	#$0f
	inc	count+1
	jsr	buildcount
	adc	#4
	tay
	lda	count+1
	adc	#0
	sta	count+1
	lda	src+1
	pha
	lda	src
	pha
	clc
	lda	dst
	adc	delta
	sta	src
	lda	dst+1
	adc	delta+1
	sta	src+1
	jsr	docopy
	pla
	sta	src
	pla
	sta	src+1
	jmp	parsetoken

docopy
	jsr	getput
	dey
	bne	docopy
	dec	count+1
	bne	docopy
done	rts

buildcount
	cmp	#$0f
	bne	+
	sta	count
-	jsr	getsrc
	tay
	clc
	adc	count
	sta	count
	lda	#0
	adc	count+1
	sta	count+1
	iny
	beq	-
	lda	count
+	rts

getput
	jsr	getsrc

putdst
	pha
	lda	dst
	bne	+
	dec	dst+1
+	dec	dst
	pla
	sty	tmpy
	ldy	#0
	sta	(dst), y
	ldy	tmpy
	rts

getsrc
	lda	src
	bne	+
	dec	src+1
+	dec	src
	sty	tmpy
	ldy	#0
	lda	(src), y
	ldy	tmpy
	rts

pakoff
	;place packed data here
